%bcond_without xpp
%bcond_without udev
%bcond_without firmware
%bcond_without extras

%kmdl dahdi-linux

Summary: Digium FXS/FXO drivers
Name: dahdi-linux
Version: 2.4.1
Release: 70%{?dist}
License: GPL
Group: Applications/Internet
URL: http://www.asterisk.org/
Source0: http://downloads.asterisk.org/pub/telephony/%{name}/releases/%{name}-%{version}.tar.gz
Source1: http://downloads.digium.com/pub/telephony/firmware/releases/dahdi-fwload-vpmadt032-1.25.0.tar.gz
Source2: http://downloads.digium.com/pub/telephony/firmware/releases/dahdi-fw-oct6114-064-1.05.01.tar.gz
Source3: http://downloads.digium.com/pub/telephony/firmware/releases/dahdi-fw-oct6114-128-1.05.01.tar.gz
Source4: http://downloads.digium.com/pub/telephony/firmware/releases/dahdi-fw-tc400m-MR6.12.tar.gz
Source5: http://downloads.digium.com/pub/telephony/firmware/releases/dahdi-fw-hx8-2.06.tar.gz
Patch0: dahdi-rhel56.diff
Patch1: dahdi-linux-2.3.0-extra.patch
Patch2: zaptel-1.4.9-diet.patch
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-buildroot
%{?with_udev:BuildRequires: udev}
%kmdl_parentdependencies

%description
Asterisk is a complete PBX in software. It runs on Linux and provides
all of the features you would expect from a PBX and more. If you want
to interface with POTS and are using Digium hardware, the Dahdi drivers
support these cards.

%if %{kmdl_userland}
%devel_package
%endif

%package -n %kmdl_name
%kmdl_dependencies
Summary: Digium kernel drivers
Group: System Environment/Kernel
# For the device management
Requires: dahdi-linux = %{evr}

%description -n %kmdl_name
Asterisk is a complete PBX in software. It runs on Linux and provides
all of the features you would expect from a PBX and more. If you want
to interface with POTS and are using Digium hardware, the Dahdi drivers
support these cards.

%kmdl_desc

%prep
%setup -q
%patch0 -p0 -b .rhel56
perl -pi -e's,udevinfo,udevadm info,' build_tools/genudevrules
for s in %{SOURCE2} %{SOURCE3} %{SOURCE4} %{SOURCE5}; do
  cp -a $s drivers/dahdi/firmware/
  tar -C drivers/dahdi/firmware -zpxf $s
done
for s in %{SOURCE1}; do
  cp -a $s drivers/dahdi/firmware/
  tar -zpxf $s
done
perl -pi -e's,firmware-loaders:.*,firmware-loaders:,' drivers/dahdi/firmware/Makefile

%if %{with extras}
%patch1 -p1 -b .extra
%endif
cd drivers/dahdi
%patch2 -p1 -b .diet
cd ../..

perl -pi -e's,mknod,:,' Makefile
grep -rl '#include <linux/config.h>' . | xargs perl -pi -e's,#include <linux/config.h>,/* #include <linux/config.h> */,'

perl -pi -e's,^always,#always,' drivers/dahdi/xpp/Kbuild

%build
%kmdl_config

%if %{kmdl_userland}
%else
# Makefile for kernel 2.4 needs DOWNLOAD=echo
make all KSRC=%{kmdl_kernelsrcdir} KVERS=%{_kernel} DOWNLOAD=echo KBUILD_VERBOSE=1
%endif

%install
rm -rf %{buildroot}
%if %{kmdl_userland}
%if %{with firmware}
%if %{with udev}
mkdir -p %{buildroot}/lib/firmware
%else
mkdir -p %{buildroot}/usr/lib/hotplug/firmware
%endif
%endif
make install-devices install-include install-firmware install-xpp-firm \
  DOWNLOAD=echo INSTALL="install -p" \
  DESTDIR=%{buildroot} ASTTOPDIR=.. HOTPLUG_FIRMWARE=yes \
  KSRC=%{kmdl_kernelsrcdir} KVERS=%{_kernel} \
  LIB_DIR=%{_libdir} \
  %{?with_udev:DYNFS=yes UDEVRULES=yes} \
  %{!?with_udev:DYNFS=}
%if %{with udev}
rm -f %{buildroot}/lib/firmware/.??*
rm -fr %{buildroot}/usr/lib/hotplug/firmware
%else
rm -f %{buildroot}/usr/lib/hotplug/firmware/.??*
rm -fr %{buildroot}/lib/firmware
%endif
%if %{with udev}
for file in %{buildroot}/etc/udev/rules.d/*.rules; do
  name=`basename $file`
  mv $file %{buildroot}/etc/udev/rules.d/60-$name
done
test "`udevinfo -V | cut -f3 -d' '`" -le 54 \
  && sed -e's,KERNEL==,KERNEL=,' %{buildroot}/etc/udev/rules.d/60-dahdi.rules
%else
cat > dahdi.devices <<EOF
%defattr(0660,asterisk,asterisk,-)
%dir /dev/dahdi
%dev(c,196,0) /dev/dahdi/ctl
%dev(c,196,250) /dev/dahdi/transcode
%dev(c,196,253) /dev/dahdi/timer
%dev(c,196,254) /dev/dahdi/channel
%dev(c,196,255) /dev/dahdi/pseudo
EOF
for i in `seq 1 250`; do
    echo "%dev(c,196,1) /dev/dahdi/$i" >> dahdi.devices
done
%endif

%else
mkdir -p %{buildroot}%{kmdl_moduledir}
make install-modules DESTDIR=%{buildroot} \
  KSRC=%{kmdl_kernelsrcdir} KVERS=%{_kernel} \
  INSTALL_MOD_DIR=updates/dahdi \
  quiet_cmd_depmod=/bin/true cmd_depmod=/bin/true
mv %{buildroot}%{kmdl_moduledir}/../* %{buildroot}%{kmdl_moduledir} || :
%endif

%post -n %kmdl_name
%kmdl_install

%postun -n %kmdl_name
%kmdl_remove

%clean
rm -rf %{buildroot}

%if %{kmdl_userland}

%files %{!?with_udev:-f dahdi.devices}
%defattr(-,root,root,-)
%doc LICENSE README*
%{?with_udev:/etc/udev/rules.d/*}
%if %{with firmware}
%if %{with udev}
/lib/firmware/*
%else
/usr/lib/hotplug/firmware/*
%endif
%endif
#/etc/hotplug
%{_datadir}/dahdi

%else

%files -n %kmdl_name
%defattr(-,root,root,-)
%{kmdl_moduledir}

%endif

%changelog
* Sat Mar 26 2011 Axel Thimm <Axel.Thimm@ATrpms.net> - 2.4.1-70
- Update to 2.4.1.

* Sun Oct 10 2010 Axel Thimm <Axel.Thimm@ATrpms.net> - 2.4.0-69
- Update to 2.4.0.

* Sun Apr 25 2010 Axel Thimm <Axel.Thimm@ATrpms.net> - 2.3.0-68
- Update to 2.3.0.

* Thu Apr  1 2010 Axel Thimm <Axel.Thimm@ATrpms.net> - 2.2.1.1-67
- Update to 2.2.1.1.

* Sun Jan 31 2010 Axel Thimm <Axel.Thimm@ATrpms.net> - 2.2.1-66
- Update to 2.2.1.

* Tue Aug 18 2009 Axel Thimm <Axel.Thimm@ATrpms.net> - 2.2.0.2-65
- Use auto devel macro.

* Thu Aug 13 2009 Axel Thimm <Axel.Thimm@ATrpms.net> - 2.2.0.2-62
- Fix download URLs.

* Wed Aug 05 2009 Tim Verhoeven <tim.verhoeven.be@gmail.com> - 2.2.0.2-61
- Update to 2.2.0.2.

* Tue Feb 3 2009 Tim Verhoeven <tim.verhoeven.be@gmail.com> - 2.1.0.4-60
- Update to 2.1.0.4.

* Wed Jan 14 2009 Leo Bergolth <leo@strike.wu-wien.ac.at> - 2.1.0.3-57
- Update to dahdi-linux 2.1.0.3.
- Add hrtimer patch for recent fedora kernels

* Sat Oct 11 2008 Axel Thimm <Axel.Thimm@ATrpms.net> - 2.0.0-56
- Update to dahdi-linux 2.0.0.

* Sat Sep 20 2008 Axel Thimm <Axel.Thimm@ATrpms.net> - 1:1.4.11-54
- Fix build for kernel 2.6.26+ (Anthony Messina <amessina@messinet.com>).

* Wed Jul 30 2008 Tim Verhoeven <tim.verhoeven.be@gmail.com> - 1:1.4.11-53
- Added fxstest to rpm.

* Tue Jul 8 2008 Tim Verhoeven <tim.verhoeven.be@gmail.com> - 1:1.4.11-52
- Added patch to fix compile issue on RHEL/CentOS 5.2 kernels.

* Sun Jun  1 2008 Axel Thimm <Axel.Thimm@ATrpms.net> - 1:1.4.11-51
- Update to 1.4.11.

* Tue Apr 22 2008 Axel Thimm <Axel.Thimm@ATrpms.net> - 1:1.4.10-49
- Update to 1.4.10.

* Sat Mar 15 2008 Axel Thimm <Axel.Thimm@ATrpms.net> - 1:1.4.9.2-48
- Update to 1.4.9.2.

* Tue Feb 19 2008 Axel Thimm <Axel.Thimm@ATrpms.net> - 1:1.4.9-47
- Update to 1.4.9.

* Tue Jan 15 2008 Axel Thimm <Axel.Thimm@ATrpms.net> - 1:1.4.8-46
- Update to 1.4.8.

* Fri Dec 28 2007 Axel Thimm <Axel.Thimm@ATrpms.net> - 1:1.4.7.1-44
- Add libusb-devel dependency (fixes #1269).

* Sat Dec 22 2007 Axel Thimm <Axel.Thimm@ATrpms.net> - 1:1.4.7.1-43
- Update to 1.4.7.1.

* Fri Nov 30 2007 Axel Thimm <Axel.Thimm@ATrpms.net> - 1:1.4.7-42
- Update to 1.4.7.

* Mon Oct 29 2007 Axel Thimm <Axel.Thimm@ATrpms.net> - 1:1.4.6-41
- Update to 1.4.6.

* Tue Oct  9 2007 Axel Thimm <Axel.Thimm@ATrpms.net> - 1:1.4.5.1-40
- Update to 1.4.5.1.

* Tue Aug 21 2007 Axel Thimm <Axel.Thimm@ATrpms.net> - 1:1.4.5-39
- Fix open call in fxotune.c.

* Sat Aug 18 2007 Axel Thimm <Axel.Thimm@ATrpms.net> - 1:1.4.5-38
- Update to 1.4.5.

* Tue Jul 24 2007 Axel Thimm <Axel.Thimm@ATrpms.net> - 1:1.4.4-37
- Fix missing config dir.

* Sat Jul 21 2007 Axel Thimm <Axel.Thimm@ATrpms.net> - 1:1.4.4-36
- Update to 1.4.4.

* Wed Jun 13 2007 Axel Thimm <Axel.Thimm@ATrpms.net> - 1:1.4.3-35
- Update to 1.4.3.

* Wed Apr 25 2007 Axel Thimm <Axel.Thimm@ATrpms.net> - 1:1.4.2.1-31
- Update to 1.4.2.1.

* Fri Mar 23 2007 Axel Thimm <Axel.Thimm@ATrpms.net> - 1:1.4.1-30
- Update to 1.4.1.

* Wed Feb 14 2007 Axel Thimm <Axel.Thimm@ATrpms.net> - 1:1.4.0-29
- Fix ownership for broken udev.

* Mon Feb 12 2007 Axel Thimm <Axel.Thimm@ATrpms.net> - 1:1.4.0-28
- Move udev rules to after default rules.

* Sun Dec 24 2006 Axel Thimm <Axel.Thimm@ATrpms.net> - 1:1.4.0-27
- Update to 1.4.0.

* Sat Dec 16 2006 Axel Thimm <Axel.Thimm@ATrpms.net> - 1:1.4.0
- Update to 1.4.0-beta3.

* Wed Dec  6 2006 Alexander Bergolth <leo@leo.wu-wien.ac.at> - 1:1.4.0-1_beta2
- First try with 1.4.0-1_beta2

* Thu Oct 26 2006 Axel Thimm <Axel.Thimm@ATrpms.net> - 1:1.2.10-22
- Fix udev rules (bug #1035), thanks to Mark Wormgoor.

* Wed Oct 25 2006 Axel Thimm <Axel.Thimm@ATrpms.net> - 1:1.2.10-21
- Rebuild w/o Fedora Extras to avoid beta bits.
- Bump epoch to superseed beta bits.

* Thu Oct 19 2006 Axel Thimm <Axel.Thimm@ATrpms.net> - 1.2.10-19
- Update to 1.2.10.

* Sat Sep  9 2006 Axel Thimm <Axel.Thimm@ATrpms.net> - 1.2.9-18
- Update to 1.2.9.

* Fri Aug 25 2006 Axel Thimm <Axel.Thimm@ATrpms.net> - 1.2.8-17
- Update to 1.2.7.

* Sat Jul 15 2006 Axel Thimm <Axel.Thimm@ATrpms.net> - 1.2.7-16
- Update to 1.2.7.

* Wed May 31 2006 Axel Thimm <Axel.Thimm@ATrpms.net>
- Update to 1.2.6.

* Mon Mar 27 2006 Axel Thimm <Axel.Thimm@ATrpms.net>
- Update to 1.2.5.

* Thu Feb 16 2006 Axel Thimm <Axel.Thimm@ATrpms.net>
- Update to 1.2.4.

* Fri Feb  3 2006 Axel Thimm <Axel.Thimm@ATrpms.net>
- Update to 1.2.3.

* Thu Jan 19 2006 Axel Thimm <Axel.Thimm@ATrpms.net>
- Update to 1.2.2.

* Mon Dec 12 2005 Axel Thimm <Axel.Thimm@ATrpms.net>
- Update to 1.2.1.

* Tue Oct 11 2005 Axel Thimm <Axel.Thimm@ATrpms.net>
- Update to 1.0.9.2.

* Thu Oct 06 2005 Mark Wormgoor <mark@wormgoor.com>
- Fix paths in zaptel.init.
- Fix compilation against 2.6.13 kernel.

* Fri Jul 15 2005 Axel Thimm <Axel.Thimm@ATrpms.net>
- Update to 1.0.9.

* Mon Jun 27 2005 Axel Thimm <Axel.Thimm@ATrpms.net>
- Update to 1.0.8.

* Mon Mar 07 2005 Mark Wormgoor <mark@wormgoor.com>
- Initial version
